﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.WinControls;
using Telerik.WinControls.UI;
using System.Drawing;

namespace ListBoxWithHostedControls
{
    public class LBItem : RadListBoxItem
    {
        private LBItemControl control;
        private RadHostItem hostItem;
        private string text;

        public LBItem()
        {
        }

        public LBItem(string text) : this()
        {
            this.text = text;
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.control = new LBItemControl();
            this.control.Text = this.text;
            this.hostItem = new RadHostItem(this.control);
            this.hostItem.StretchHorizontally = false;
            this.hostItem.StretchVertically = false;
            this.Children.Add(this.hostItem);
        }

        public override string Text
        {
            get
            {
                if (this.control == null)
                    return this.text;
                return this.control.Text;
            }
            set
            {
                this.text = value;
                if (this.control != null)
                {
                    this.control.Text = value;
                }
            }
        }

        public RadHostItem HostItem
        {
            get
            {
                this.EnsureChildElements();
                return this.hostItem;
            }
        }
    }
}
